package com.gxwebsoft.apps.controller;

import com.gxwebsoft.common.core.web.BaseController;
import com.gxwebsoft.apps.service.HualalaFoodCategoryService;
import com.gxwebsoft.apps.entity.HualalaFoodCategory;
import com.gxwebsoft.apps.param.HualalaFoodCategoryParam;
import com.gxwebsoft.common.core.web.ApiResult;
import com.gxwebsoft.common.core.web.PageResult;
import com.gxwebsoft.common.core.web.PageParam;
import com.gxwebsoft.common.core.web.BatchParam;
import com.gxwebsoft.common.core.annotation.OperationLog;
import com.gxwebsoft.common.system.entity.User;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import java.util.List;

/**
 * 菜品分类控制器
 *
 * @author 科技小王子
 * @since 2023-01-12 09:49:46
 */
@Api(tags = "菜品分类管理")
@RestController
@RequestMapping("/api/apps/hualala-food-category")
public class HualalaFoodCategoryController extends BaseController {
    @Resource
    private HualalaFoodCategoryService hualalaFoodCategoryService;

    @PreAuthorize("hasAuthority('apps:hualalaFoodCategory:list')")
    @OperationLog
    @ApiOperation("分页查询菜品分类")
    @GetMapping("/page")
    public ApiResult<PageResult<HualalaFoodCategory>> page(HualalaFoodCategoryParam param) {
        PageParam<HualalaFoodCategory, HualalaFoodCategoryParam> page = new PageParam<>(param);
        page.setDefaultOrder("create_time desc");
        return success(hualalaFoodCategoryService.page(page, page.getWrapper()));
        // 使用关联查询
        //return success(hualalaFoodCategoryService.pageRel(param));
    }

    @PreAuthorize("hasAuthority('apps:hualalaFoodCategory:list')")
    @OperationLog
    @ApiOperation("查询全部菜品分类")
    @GetMapping()
    public ApiResult<List<HualalaFoodCategory>> list(HualalaFoodCategoryParam param) {
        PageParam<HualalaFoodCategory, HualalaFoodCategoryParam> page = new PageParam<>(param);
        page.setDefaultOrder("create_time desc");
        return success(hualalaFoodCategoryService.list(page.getOrderWrapper()));
        // 使用关联查询
        //return success(hualalaFoodCategoryService.listRel(param));
    }

    @PreAuthorize("hasAuthority('apps:hualalaFoodCategory:list')")
    @OperationLog
    @ApiOperation("根据id查询菜品分类")
    @GetMapping("/{id}")
    public ApiResult<HualalaFoodCategory> get(@PathVariable("id") Integer id) {
        return success(hualalaFoodCategoryService.getById(id));
        // 使用关联查询
        //return success(hualalaFoodCategoryService.getByIdRel(id));
    }

    @PreAuthorize("hasAuthority('apps:hualalaFoodCategory:save')")
    @OperationLog
    @ApiOperation("添加菜品分类")
    @PostMapping()
    public ApiResult<?> save(@RequestBody HualalaFoodCategory hualalaFoodCategory) {
        if (hualalaFoodCategoryService.save(hualalaFoodCategory)) {
            return success("添加成功");
        }
        return fail("添加失败");
    }

    @PreAuthorize("hasAuthority('apps:hualalaFoodCategory:update')")
    @OperationLog
    @ApiOperation("修改菜品分类")
    @PutMapping()
    public ApiResult<?> update(@RequestBody HualalaFoodCategory hualalaFoodCategory) {
        if (hualalaFoodCategoryService.updateById(hualalaFoodCategory)) {
            return success("修改成功");
        }
        return fail("修改失败");
    }

    @PreAuthorize("hasAuthority('apps:hualalaFoodCategory:remove')")
    @OperationLog
    @ApiOperation("删除菜品分类")
    @DeleteMapping("/{id}")
    public ApiResult<?> remove(@PathVariable("id") Integer id) {
        if (hualalaFoodCategoryService.removeById(id)) {
            return success("删除成功");
        }
        return fail("删除失败");
    }

    @PreAuthorize("hasAuthority('apps:hualalaFoodCategory:save')")
    @OperationLog
    @ApiOperation("批量添加菜品分类")
    @PostMapping("/batch")
    public ApiResult<?> saveBatch(@RequestBody List<HualalaFoodCategory> list) {
        if (hualalaFoodCategoryService.saveBatch(list)) {
            return success("添加成功");
        }
        return fail("添加失败");
    }

    @PreAuthorize("hasAuthority('apps:hualalaFoodCategory:update')")
    @OperationLog
    @ApiOperation("批量修改菜品分类")
    @PutMapping("/batch")
    public ApiResult<?> removeBatch(@RequestBody BatchParam<HualalaFoodCategory> batchParam) {
        if (batchParam.update(hualalaFoodCategoryService, "id")) {
            return success("修改成功");
        }
        return fail("修改失败");
    }

    @PreAuthorize("hasAuthority('apps:hualalaFoodCategory:remove')")
    @OperationLog
    @ApiOperation("批量删除菜品分类")
    @DeleteMapping("/batch")
    public ApiResult<?> removeBatch(@RequestBody List<Integer> ids) {
        if (hualalaFoodCategoryService.removeByIds(ids)) {
            return success("删除成功");
        }
        return fail("删除失败");
    }

}
